package YClass;

import java.lang.*;
import java.awt.*;
import java.util.*;
    /**
     * Constructs a newly allocated YCalc object for calculates function Y=f(x).
     * <center><p><b>Numeric operations</b></center>
     * <table BORDER CELLSPACING=0 CELLPADDING=0 COLS=2 WIDTH="100%" ><tr>
     * <td WIDTH="5%">E</td><td>The double value that is closer than any other
     * to e, the base of the natural logarithms.</td></tr><tr><td>PI</td>
     * <td>The double value that is closer than any other to pi, the ratio of
     * the circumference of a circle to its diameter.</td></tr><tr>
     * <td>(...)^(...)</td><td>Returns of value of the first argument raised
     * to the power of the second argument.</td></tr><tr><td>abs(...)&nbsp;
     * </td><td>Returns the absolute value.</td></tr><tr><td>acos(...)</td>
     * <td>Returns the arc cosine of an angle, in the range of 0.0 through pi.
     * </td></tr><tr><td>asin(...)</td><td>Returns the arc sine of an angle,
     * in the range of -pi/2 through pi/2.</td></tr><tr><td>atan(...)</td>
     * <td>Returns the arc tangent of an angle, in the range of -pi/2 through
     * pi/2.</td></tr><tr><td>cos(...)</td><td>Returns the trigonometric 
     * cosine of an angle.</td></tr><tr><td>log(...)</td><td>Returns the 
     * natural logarithm (base e).</td></tr><tr><td>sin(..)</td><td>Returns
     * the trigonometric sine of an angle.</td></tr><tr><td>sqrt(..)</td>
     * <td>Returns the square root of a double value.</td></tr><tr>
     * <td>tan(...)</td><td>Returns the trigonometric tangent of an angle.
     * </td></tr></table>
     */
public class YCalc{
	private static String strFunction = "";
    /**
     * Constructs a newly allocated YCalc object.
     */
  public YCalc(){
  }
  	 /**
     * Calculates function Y=f(x).
     *
     * @param x an double value x.
     */
  public static double calc(double x) throws Exception{
  	if(strFunction.length()<1)throw new Exception("Null function Y=f(x).");
  	String st=insX(strFunction,x);
  	int i = st.lastIndexOf('(');
  	while(i!=-1){
  		String st1 = st.substring(i);
  		int j = st1.indexOf(')');
  		if(j!=-1){
  			String st2 = convert(st1.substring(1,j));
  			String st3 = st.substring(0,i);
  			if((i-4)>=0 && st.substring(i-4,i).equals("asin")){
  				st2=DoubleToStr(Math.asin(StrToFloat(st2)));
  				st3=st.substring(0,i-4);
  			}else if((i-4)>=0 && st.substring(i-4,i).equals("acos")){
  				st2=DoubleToStr(Math.acos(StrToFloat(st2)));
  				st3=st.substring(0,i-4);
  			}else if((i-4)>=0 && st.substring(i-4,i).equals("atan")){
  				st2=DoubleToStr(Math.atan(StrToFloat(st2)));
  				st3=st.substring(0,i-4);
  			}else if((i-4)>=0 && st.substring(i-4,i).equals("sqrt")){
  				st2=Math.sqrt(StrToFloat(st2))+"";
  				st3=st.substring(0,i-4);
  			}else	if((i-3)>=0 && st.substring(i-3,i).equals("log")){
  				st2=DoubleToStr(Math.log(StrToFloat(st2)));
  				st3=st.substring(0,i-3);
  			}else	if((i-3)>=0 && st.substring(i-3,i).equals("sin")){
  				float f = StrToFloat(st2);
  				if(Math.abs(f/Math.PI)<Math.abs(((int)(f/Math.PI))*1.00001f)) 
  					st2="0";
  					else 
  			    st2=DoubleToStr(Math.sin(StrToFloat(st2)));
  			  st3=st.substring(0,i-3);
  			}else if((i-3)>=0 && st.substring(i-3,i).equals("cos")){
  				float f = StrToFloat(st2);
  				if(Math.abs((Math.abs(f)+Math.PI/2)/Math.PI)<Math.abs(((int)((Math.abs(f)+Math.PI/2)/Math.PI))*1.00001f)) 
  					st2="0";
  					else 
  			    st2=DoubleToStr(Math.cos(StrToFloat(st2)));
  			  st3=st.substring(0,i-3);
  			}else if((i-3)>=0 && st.substring(i-3,i).equals("tan")){
  				st2=DoubleToStr(Math.tan(StrToFloat(st2)));
  				st3=st.substring(0,i-3);
  			}else if((i-3)>=0 && st.substring(i-3,i).equals("abs")){
  				st2=Math.abs(StrToFloat(st2))+"";
  				st3=st.substring(0,i-3);
  			}
  		  st=st3+st2+st1.substring(j+1);
  		  i = st.lastIndexOf('(');
  		}else{throw new Exception("Error: malformed list. ')' expected.");}
  	}
 		i = st.lastIndexOf(')');
 		if(i!=-1){throw new Exception("Error: extra right paren. '(' expected.");}
  	return StrToFloat(convert(st));
  }

  private static float StrToFloat(String st)throws Exception{
  	float value=Float.NaN;
  	try{
  		Float d = Float.valueOf(st);
  	  value = d.floatValue();
    }catch(Exception e){
    	try{
    	  int i = st.lastIndexOf('#');
    	  st = st.substring(i+1);
  		  Float d = Float.valueOf(st);
  	    value = d.floatValue();
      	if(i!=-1){
      		for(int j=0; j<=i; j++){
      			value=-1*value;
      		}
    	  }
    	}catch(Exception e1){throw new Exception(e1.getMessage());}
    }
    return value;
  }

  private static String DoubleToStr(double d)throws Exception{
  	String st = d+"";
  	if(d<0) st="#"+st.substring(1);
  	  else st=d+"";
    return st;
  }
  
  
  private static String opt(String st){
  	st = st.toLowerCase().trim();
  	int i = st.indexOf(' ');
  	while(i != -1){
  		st=st.substring(0,i)+st.substring(i+1);
  		i = st.indexOf(' ');
  	}
  	i = st.indexOf("pi");
  	while(i != -1){
  		st=st.substring(0,i)+Math.PI+st.substring(i+2);
  		i = st.indexOf("pi");
  	}  	
  	i = st.indexOf("e");
  	while(i != -1){
  		st=st.substring(0,i)+Math.E+st.substring(i+1);
  		i = st.indexOf("e");
  	}  	
  	return st;	
  }

  private static String insX(String st, double x){
  	int i = st.indexOf('x');
  	while(i != -1){
  		if(x<0){
  			st=st.substring(0,i)+"#"+Math.abs(x)+st.substring(i+1);
  		}else{st=st.substring(0,i)+x+st.substring(i+1);}
  		i = st.indexOf('x');
  	}
  	return st;	
  }

  private static String convert(String st)throws Exception{
  	int i = st.lastIndexOf('^');
  	if(i==0 || i==st.length()){throw new Exception("Error: Bad argument (...)^(...)");}
  	while(i!=-1){
  		String stR = st.substring(i+1);
  		String stL = st.substring(0,i);
  		if(stR.indexOf('-')==0){stR="#"+stR.substring(1);}
  		int i1 = stR.indexOf('/');
  		int i2 = stR.indexOf('*');
  		int i3 = stR.indexOf('+');
  		int i4 = stR.indexOf('-');
  		int i5 = 1000;
  		if(i1>0){i5 = Math.min(i1,i5);}
  		if(i2>0){i5 = Math.min(i2,i5);}
  		if(i3>0){i5 = Math.min(i3,i5);}
  		if(i4>0){i5 = Math.min(i4,i5);}
  		if(i5==1000){i5 = stR.length();}
  		double R = StrToFloat(stR.substring(0,i5));
  		i1 = Math.max(stL.lastIndexOf('^'),stL.lastIndexOf('/'));
  		i2 = Math.max(stL.lastIndexOf('*'),stL.lastIndexOf('+'));
  		i3 = Math.max(stL.lastIndexOf('-'),i1);
  		i4 = Math.max(i3,i2);
  		double L = StrToFloat(stL.substring(i4+1,stL.length()));
  		double p = Math.pow(L,R);
  		if(p<0)
  			st=stL.substring(0,i4+1)+"#"+Math.abs(p)+stR.substring(i5);
  			else st=stL.substring(0,i4+1)+p+stR.substring(i5);
  		i = st.lastIndexOf('^');
  	}
  	i = st.lastIndexOf('/');
  	if(i==0 || i==st.length()){throw new Exception("Error: Bad argument (...)/(...)");}
  	while(i!=-1){
  		String stR = st.substring(i+1);
  		String stL = st.substring(0,i);
  		if(stR.indexOf('-')==0){stR="#"+stR.substring(1);}
  		int i2 = stR.indexOf('*');
  		int i3 = stR.indexOf('+');
  		int i4 = stR.indexOf('-');
  		int i5 = 1000;
  		if(i2>0){i5 = Math.min(i2,i5);}
  		if(i3>0){i5 = Math.min(i3,i5);}
  		if(i4>0){i5 = Math.min(i4,i5);}
  		if(i5==1000){i5 = stR.length();}
  		double R = StrToFloat(stR.substring(0,i5));
  		i2 = Math.max(stL.lastIndexOf('*'),stL.lastIndexOf('+'));
  		i3 = Math.max(stL.lastIndexOf('-'),stL.lastIndexOf('/'));
  		i4 = Math.max(i3,i2);
  		double L = StrToFloat(stL.substring(i4+1,stL.length()));
  		double p = L/R;
  		if(p<0)
  			st=stL.substring(0,i4+1)+"#"+Math.abs(p)+stR.substring(i5);
  			else st=stL.substring(0,i4+1)+p+stR.substring(i5);
  		i = st.lastIndexOf('/');
  	}
  	i = st.lastIndexOf('*');
  	if(i==0 || i==st.length()){throw new Exception("Error: Bad argument (...)*(...)");}
  	while(i!=-1){
  		String stR = st.substring(i+1);
  		String stL = st.substring(0,i);
  		if(stR.indexOf('-')==0){stR="#"+stR.substring(1);}
  		int i3 = stR.indexOf('+');
  		int i4 = stR.indexOf('-');
  		int i5 = 1000;
  		if(i3>0){i5 = Math.min(i3,i5);}
  		if(i4>0){i5 = Math.min(i4,i5);}
  		if(i5==1000){i5 = stR.length();}
  		double R = StrToFloat(stR.substring(0,i5));
  		i3 = Math.max(stL.lastIndexOf('-'),stL.lastIndexOf('/'));
  		i4 = Math.max(i3,stL.lastIndexOf('+'));
  		double L = StrToFloat(stL.substring(i4+1,stL.length()));
  		double p = L*R;
  		if(p<0)
  			st=stL.substring(0,i4+1)+"#"+Math.abs(p)+stR.substring(i5);
  			else st=stL.substring(0,i4+1)+p+stR.substring(i5);
  		i = st.lastIndexOf('*');
  	}
  	i = st.lastIndexOf('-');
  	if(i==st.length()){throw new Exception("Error: Bad argument (...)-(...)");}
  	while(i!=-1){
  		String stR = st.substring(i+1);
  		String stL = st.substring(0,i);
  		if(stL.indexOf('-')==0){stL="#"+stL.substring(1);}
  		int i4 = stR.indexOf('+');
  		int i5 = 1000;
  		if(i4>0){i5 = Math.min(i4,i5);}
  		if(i5==1000){i5 = stR.length();}
  		double R = StrToFloat(stR.substring(0,i5));
  		i4 = Math.max(stL.lastIndexOf('-'),stL.lastIndexOf('+'));
  		if(i4!=-1 && stL.charAt(i4)=='-'){i4=i4-1;}
  		if(i4!=-1 && stL.charAt(i4)=='+'){i4=i4-1;}
  		if(i4==-1 && stL.length()==0){stL="0";}
  		double L = StrToFloat(stL.substring(i4+1,stL.length()));
  		double p = L-R;
  		if(p<0)
  			if(i4!=-1)st=stL.substring(0,i4+1)+"+#"+Math.abs(p)+stR.substring(i5);
  			  else st=stL.substring(0,i4+1)+"#"+Math.abs(p)+stR.substring(i5);
  			else st=stL.substring(0,i4+1)+p+stR.substring(i5);
  		i = st.lastIndexOf('-');
  	}
  	i = st.lastIndexOf('+');
  	if(i==0 || i==st.length()){throw new Exception("Error: Bad argument (...)+(...)");}
  	while(i!=-1){
  		String stR = st.substring(i+1);
  		String stL = st.substring(0,i);
  		if(stL.indexOf('+')==0){stL=stL.substring(1);}
  		int i5 = stR.length();
  		double R = StrToFloat(stR.substring(0,i5));
  		int i4 = stL.lastIndexOf('+');
  		double L = StrToFloat(stL.substring(i4+1,stL.length()));
  		double p = L+R;
  		if(p<0)
  			if(i4!=-1)st=stL.substring(0,i4+1)+"+#"+Math.abs(p)+stR.substring(i5);
  			  else st=stL.substring(0,i4+1)+"#"+Math.abs(p)+stR.substring(i5);
  			else st=stL.substring(0,i4+1)+p+stR.substring(i5);
  		i = st.lastIndexOf('+');
  	}
    return st;	
  }

    /**
     * Set function Y=f(x).
     *
     * @param st an String circumscribing function Y=f(x).
     */

  public static void setFunction(String st){
  	strFunction = opt(st);
  }
  

}