package YClass;

import java.awt.*;
import java.net.*;
import java.lang.Math;

public class YLoadImage extends Canvas {
	private Image img;
	private int wImg;
  private int hImg;

    /**
     * Creates a Canvas with an Image.
     *
     * @param i the image.
     */
	public YLoadImage(Image i){
	 	MediaTracker mt = new MediaTracker(this);
		mt.addImage(i,0);
		try {
			mt.waitForAll();
		}catch(InterruptedException e){System.out.println(e);}
		img = i;
    setSize(img.getWidth(this),img.getHeight(this));
 	}
    /**
     * Creates a Canvas with an Image.
     *
     * @param url an absolute URL giving the location of the image.
     */ 	
  public YLoadImage(URL url){
    Image i = Toolkit.getDefaultToolkit().getImage(url);
	 	MediaTracker mt = new MediaTracker(this);
		mt.addImage(i,0);
		try {
			mt.waitForAll();
		}catch(InterruptedException e){System.out.println(e);}
		img = i;
    setSize(img.getWidth(this),img.getHeight(this));
 	}
    /**
     * Creates a Canvas with an Image.
     *
     * @param st an absolute String giving the location of the image.
     */ 	
  public YLoadImage(String st){
    Image i = Toolkit.getDefaultToolkit().getImage(st);
	 	MediaTracker mt = new MediaTracker(this);
		mt.addImage(i,0);
		try {
			mt.waitForAll();
		}catch(InterruptedException e){System.out.println(e);}
		img = i;
		setSize(img.getWidth(this),img.getHeight(this));
 	}

	public void paint(Graphics g){
		if (img == null){g.drawString("Can'not load image",10,30);}else{
      int w = this.getSize().width;
      int h = this.getSize().height;
      int wImg = img.getWidth(this);
      int hImg = img.getHeight(this);
      if(w > wImg && h > hImg)
				{g.drawImage(img,Math.round((w-wImg)/2),Math.round((h-hImg)/2),this);}else
				{g.drawImage(img,0,0,w,h,this);}
			this.validate();
		}
	}
    /**
     * Gets the preferred size of this component.
     * @return A dimension object indicating this component's preferred size.
     * @see #getMinimumSize
     */  	
	public Dimension getPreferredSize(){
		return new Dimension(img.getWidth(this), img.getHeight(this));
	}
    /**
     * Gets the mininimum size of this component.
     * @return A dimension object indicating this component's minimum size.
     * @see #getPreferredSize
     */		
	public Dimension getMinimumSize(){
		return getPreferredSize();
	}
    /**
     * Gets the Image of this component.
     * @return A Image of this component.
     */		
  public Image getImage(){
    return img;
  }

    /**
     * Gets the Image of this component.
     * @param i Image of this component.
     */		  
  public void setImage(Image i){
    img = i;
    repaint();
  }
}